// dll to interpret the data contained in a US caller ID
// data packet
// (c) nailed barnacle 1999

#include "nbcid.h"
#include <windows.h>
#include <stdio.h>

#define FALSE 0
#define TRUE 1

char * _stdcall NbCidGetSeize (char * marker,int count)
{
	// moves a pointer to the first character of the data
	// returns null if no seize string
	// returns pointing to 0x80 char which marks the start
	// of the data block

int where = 0;

	while ((marker[where++] != (char)0x55) && (where < count));
	if (where >= count)
		return NULL;
	
	// otherwise, we need to wander past the 0x55
	while ((marker[where++] != (char)0x80) && (where < count));
	if (where >= count)
		return NULL;

	return &marker[--where];
	// return pointing to the first 0x80 after 0x55...
}

int _stdcall NbCidChecksum (char * marker, int * length)
{
// returns true if checksum matches correctly
// when called, marker should point to message start 0x80
int chex = 0;
int q;

	length[0] = (int)marker[1];
	for (q=0; q<marker[1]+3; q++)
	{
		chex += marker[q];
	}
	chex &= 0xff;
	//if (chex)
	//	return FALSE;
	//else
	//	return TRUE;
	return !chex;
}

char * _stdcall NbCidGetInfo (char * decoded, char * output)
{
// reads and formats the data into 
char months[][12] = {
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December" };
int month;
//int params;
int qq;
int r;
char * ptr;

	qq = 0;
	switch (decoded[qq])			// this should be a parameter type
	{
		case 0x01:								// date and time
															// this is always 8 chars
			month = (((decoded[qq+2]-0x30)*10)+(decoded[qq+3]-0x30));
			sprintf(output,"%s %c%c, %c%c:%c%c\n",
							months[month-1],
							decoded[qq+4],decoded[qq+5],
							decoded[qq+6],decoded[qq+7],
							decoded[qq+8],decoded[qq+9]);
			qq+=10;
			break;

		case 0x02:								// calling identity
															// variable length...
			sprintf(output,"Calling number: ");
			ptr = &output[strlen(output)];
			for (r=0; r<decoded[qq+1]; r++)
				ptr++[0] = decoded[qq+2+r];
			ptr[0] = 0;
			strcat(output,"\n");
			qq+=(decoded[qq+1]+2);
			break;

		case 0x04:								// no call id reason
															// always 1 byte
			sprintf (output,"No calling line identification: ");
			switch (decoded[qq+2])
			{
				case 'O':
					sprintf(output,"Number unavailable\n");
					break;
				case 'P':
					sprintf(output,"Private\n");
					break;
				default:
					sprintf(output,"Unknown reason\n");
					break;
			}
			qq+=3;
			break;

		case 0x07:								// calling name
															// variable length
			sprintf(output,"Caller name: ");
			ptr = &output[strlen(output)];
			for (r=0; r<decoded[qq+1]; r++)
				ptr++[0] = decoded[qq+2+r];
			ptr[0] = 0;
			strcat(output,"\n");
			qq+=(decoded[qq+1]+2);
			break;


		case 0x08:								// no call name reason
															// always 1 byte
			sprintf(output,"No caller identification: ");
			switch (decoded[qq+2])
			{
				case 'O':
					sprintf(output,"Number unavailable\n");
					break;
				case 'P':
					sprintf(output,"Private\n");
					break;
				default:
					sprintf(output,"Unknown reason\n");
					break;
			}
			qq+=3;
			break;

		case 0x11:								// call type
															// always 1 byte
			sprintf(output,"Call type: ");
			switch (decoded[qq+2])
			{
				case 0x01:
					sprintf(output,"Voice\n");
					break;
				case 0x02:
					sprintf(output,"CLI Ring Back when free\n");
					break;
				case 0x03:
					sprintf(output,"Calling Name Delivery\n");
					break;
				case 0x81:
					sprintf(output,"Message Waiting\n");
					break;
				default:
					sprintf(output,"No Idea...\n");
					break;
			}
			qq+=3;
			break;

		case 0x12:								// number forwarded from
															// variable length...
			sprintf(output,"Call forwarded from: ");
			ptr = &output[strlen(output)];
			for (r=0; r<decoded[qq+1]; r++)
				ptr++[0] = decoded[qq+2+r];
			ptr[0] = 0;
			strcat(output,"\n");
			qq+=(decoded[qq+1]+2);
			break;

		case 0x15:								// type of forwarded call
															// always 1 byte
			sprintf(output,"Forwarded call type: ");
			switch (decoded[qq+2])
			{
				case 0x00:
					sprintf(output,"Unavailable or unknown call type\n");
					break;
				case 0x01:
					sprintf(output,"Forwarded call on busy\n");
					break;
				case 0x02:
					sprintf(output,"Forwarded call on no reply\n");
					break;
				case 0x03:
					sprintf(output,"Unconditional forwarded call\n");
					break;
				case 0x04:
					sprintf(output,"Deflected call (after alerting)\n");
					break;
				case 0x05:
					sprintf(output,"Deflected call (immediate)\n");
					break;
				case 0x06:
					sprintf(output,"Forwarded call on inability to reach mobile\n");
					break;
				default:
					sprintf(output,"No Idea...\n");
					break;
			}
			qq+=3;
			break;

		default:									// unknown type
			sprintf(output,"Unknown parameter type %x, %d characters\n",
							decoded[qq],decoded[qq+1]);
			qq += (decoded[qq+1]+2);
			break;
	}

	return &decoded[qq];
}
